//+------------------------------------------------------------------+
//|                                           Hybrid Trend Index.mq4 |
//|                                                       Steve Hogg |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Steve Hogg"
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_minimum -100
#property indicator_maximum 100
#property indicator_buffers 6
#property indicator_color1 LightGreen
#property indicator_color2 LightCoral
#property indicator_color3 DarkGreen
#property indicator_color4 Maroon
#property indicator_color5 Yellow
#property indicator_color6 DodgerBlue


//---- input parameters
extern int       TimeFrame=0;
//---- input parameters
/*************************************************************************
PERIOD_M1   1
PERIOD_M5   5
PERIOD_M15  15
PERIOD_M30  30 
PERIOD_H1   60
PERIOD_H4   240
PERIOD_D1   1440
PERIOD_W1   10080
PERIOD_MN1  43200
You must use the numeric value of the timeframe that you want to use
when you set the TimeFrame' value with the indicator inputs.
**************************************************************************/

//---- buffers
double HTI_Buffer[];
double Signal_Buffer[];
double PosBuffer[];
double NegBuffer[];
double FULLPosBuffer[];
double FULLNegBuffer[];


//---- variables

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(8);
   
   SetIndexStyle(0,DRAW_HISTOGRAM,EMPTY,5);
   SetIndexBuffer(0,FULLPosBuffer);
   
   SetIndexStyle(1,DRAW_HISTOGRAM,EMPTY,5);
   SetIndexBuffer(1,FULLNegBuffer);
   
   SetIndexStyle(2,DRAW_HISTOGRAM,EMPTY,3);
   SetIndexBuffer(2,PosBuffer);
   
   SetIndexStyle(3,DRAW_HISTOGRAM,EMPTY,3);
   SetIndexBuffer(3,NegBuffer);
   
   SetIndexStyle(4,DRAW_LINE,EMPTY,2);
   SetIndexBuffer(4,HTI_Buffer);
   
   SetIndexStyle(5,DRAW_LINE,EMPTY,2);
   SetIndexBuffer(5,Signal_Buffer);

   switch(TimeFrame)
   {
      case 1 : string TimeFrameStr="M1"; break;
      case 5 : TimeFrameStr="M5"; break;
      case 15 : TimeFrameStr="M15"; break;
      case 30 : TimeFrameStr="M30"; break;
      case 60 : TimeFrameStr="H1"; break;
      case 240 : TimeFrameStr="H4"; break;
      case 1440 : TimeFrameStr="D1"; break;
      case 10080 : TimeFrameStr="W1"; break;
      case 43200 : TimeFrameStr="MN1"; break;
      default : TimeFrameStr="Current Timeframe";
   }
   
   
   IndicatorShortName("HTI_Osc ("+TimeFrameStr+")");
   SetIndexLabel(2,"HTI");
   SetIndexLabel(3,"Signal");

   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| MTF 
//+------------------------------------------------------------------+
int start()
  {
   datetime TimeArray[];
   int    i,limit,y=0,counted_bars=IndicatorCounted();

// Plot defined time frame on to current time frame
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
   
   limit=Bars-counted_bars;
   limit=Bars-counted_bars;
   for(i=0,y=0;i<limit;i++)
   {
   if (Time[i]<TimeArray[y]) y++;

/***********************************************************   
   Add your main indicator loop below.  You can reference an existing
      indicator with its iName  or iCustom.
   Rule 1:  Add extern inputs above for all neccesary values   
   Rule 2:  Use 'TimeFrame' for the indicator time frame
   Rule 3:  Use 'y' for your indicator's shift value
 **********************************************************/  
 

   HTI_Buffer[i] = iCustom(NULL,TimeFrame,"HTI",0,y);  
   Signal_Buffer[i] = iCustom(NULL,TimeFrame,"HTI",1,y); 
   
   if (HTI_Buffer[i]<Signal_Buffer[i])
   {
      FULLPosBuffer[i]=0;
      FULLNegBuffer[i]=-100;
      PosBuffer[i]=0;
      NegBuffer[i]=(HTI_Buffer[i]-Signal_Buffer[i])*2;
   }
   else
   {
      PosBuffer[i]=(HTI_Buffer[i]-Signal_Buffer[i])*2;
      NegBuffer[i]=0;
      FULLPosBuffer[i]=100;
      FULLNegBuffer[i]=0;
   }
   
   
   }  
   return(0);
  }
//+------------------------------------------------------------------+

